---
title: HTMLImageElement.decode()
slug: Web/API/HTMLImageElement/decode
tags:
  - API
  - Decode
  - Graphics
  - HTML DOM
  - HTMLImageElement
  - Images
  - Loading
  - Method
  - Performance
  - Reference
  - async
  - asynchronous
  - decoding
---
<div>{{APIRef("HTML DOM")}}</div>

<p class="summary"><span class="seoSummary">The <strong><code>decode()</code></strong> method of the {{domxref("HTMLImageElement")}} interface returns a {{jsxref("Promise")}} that resolves when the image is decoded and it is safe to append the image to the DOM.</span> This can be used to initiate loading of the image prior to attaching it to an element in the DOM (or adding it to the DOM as a new element), so that the image can be rendered immediately upon being added to the DOM. This, in turn, prevents the rendering of the next frame after adding the image to the DOM from causing a delay while the image loads.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <var>promise</var> = <em>HTMLImageElement</em>.decode();</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref('Promise')}} which is resolved once the image data is ready to be used.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>EncodingError</code></dt>
 <dd>A {{domxref('DOMException')}} indicating that an error occurred while decoding the image.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>One potential use case for <code>decode()</code>: when loading very large images (for example, in an online photo album), you can present a low resolution thumbnail image initially and then replace that image with the full-resolution image by instantiating a new {{domxref("HTMLImageElement")}}, setting its source to the full-resolution image's URL, then using <code>decode()</code> to get a promise which is resolved once the full-resolution image is ready for use. At that time, you can then replace the low-resolution image with the full-resolution one that's now available.</p>

<h2 id="Examples">Examples</h2>

<p>The following example shows how to use the <code>decode()</code> method to control when an image is appended to the DOM. Without a {{domxref('Promise')}}-returning method, you would add the image to the DOM in a {{event("load")}} event handler, such as by using the {{domxref("GlobalEventHandlers.onload", "img.onload")}} event handler, and by handling the error in the {{event("error")}} event's handler.</p>

<pre class="brush: js">const img = new Image();
img.src = 'nebula.jpg';
img.decode()
.then(() =&gt; {
  document.body.appendChild(img);
})
.catch((encodingError) =&gt; {
  // Do something with the error.
})
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG','#dom-img-decode','decode()')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLImageElement.decode")}}</p>
